
package magercises.cats.solution;


/* 
	Use the WaitStack (a blocking stack) to act as an argument stack
	for a simple consumer.  Here the consumer, CatMachine, waits until
	it can pull out some number of objects from its input stack, cats
	them together as strings, then sends it to it's output, which is
	another consumer.  A new subclass of TextArea is introduced to 
	act as a final consumer and show the output.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class CatMachine extends Thread implements Consumer {
  WaitStack argStack;
  Consumer output;
  int numArgs;


  public CatMachine(int numargs, Consumer c)  {
	numArgs = numargs;
	output = c;
	argStack = new WaitStack();
  }    
  public void inputItem(Object o) {
	argStack.push(o);
  }    
  public void run() {
	StringBuffer buff = new StringBuffer(20);
	for(int i = 0; i < numArgs; i++) {
	  buff.append(argStack.pop().toString());
	}
	output.inputItem(buff.toString());
  }    
}