
package magercises.cats.solution;


/* 
	Use the WaitStack (a blocking stack) to act as an argument stack
	for a simple consumer.  Here the consumer, CatMachine, waits until
	it can pull out some number of objects from its input stack, cats
	them together as strings, then sends it to it's output, which is
	another consumer.  A new subclass of TextArea is introduced to 
	act as a final consumer and show the output.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class WaitStack {
  protected Vector stackVector;
  

  public WaitStack() {
	stackVector = new Vector(10);
  }    
  /** pop will force caller to wait if stack is empty */
  public synchronized Object pop() {
	Object item;
	while(stackVector.size() == 0) {
	try { wait();  }
	catch (InterruptedException e) { }
	  }	
	item = stackVector.elementAt(stackVector.size()-1);
	stackVector.removeElementAt(stackVector.size()-1);
	return item;
  }    
  public synchronized void push(Object item) {
	stackVector.addElement(item);
	notifyAll();
  }    
  public String toString() {
	return "WaitStack: " + stackVector;
  }    
}