
package magercises.finallyclause.solution;

class AirplaneFactory {
  private boolean enginesGood;
  private boolean framesGood;
  private boolean assemblyGood;


  public AirplaneFactory(boolean goodEngines,
			 boolean goodFrames,
			 boolean goodAssemblies) {
	enginesGood = goodEngines;
	framesGood = goodFrames;
	assemblyGood = goodAssemblies;
  }    
   protected void assembleComponents() throws AssemblyException {
	 if(!assemblyGood)
	  throw new AssemblyException("ASMBAD");
   }      
  public void buildAirplane() {
	System.out.println("begin buildAirplane process");
	try {
	  buildComponents();
	  assembleComponents();
	}
	catch(AirplaneFactoryException e) {
	  System.out.println(e);
	}
   finally {
	 System.out.println("end buildAirplane process");
   }
  }    
   protected void buildComponents() throws ComponentException {
	 System.out.println("begin buildComponent process");
	 try {
	   buildEngine();
	   buildFrame();
	 }
	 catch(AirplaneFactoryException e) {
	   System.out.println(e);
	   throw new ComponentException("CPNTBAD");
	 }
	 finally {
	   System.out.println("end buildComponent process");
	 }
   }      
   protected void buildEngine() throws EngineException {
	 if(!enginesGood)
	  throw new EngineException("ENGBAD");
   }      
   protected void buildFrame() throws FrameException {
	 if(!framesGood)
	  throw new FrameException("FRMBAD");
   }      
}