
package magercises.throwclause.solution;

class AirplaneFactory {
  private boolean enginesGood;
  private boolean framesGood;
  private boolean assemblyGood;


  public AirplaneFactory(boolean goodEngines,
			 boolean goodFrames,
			 boolean goodAssemblies) {
	enginesGood = goodEngines;
	framesGood = goodFrames;
	assemblyGood = goodAssemblies;
  }    
   protected void assembleComponents() throws AssemblyException {
	 if(!assemblyGood)
	  throw new AssemblyException();
   }      
  public void buildAirplane() {
	try {
	  buildComponents();
	  assembleComponents();
	}
	catch(AssemblyException e1) {
	  System.out.println("Assembly Error");
	}
	catch(ComponentException e1) {
	  System.out.println("Component Error");
	}
  }    
   protected void buildComponents() throws ComponentException {
	 try {
	   buildEngine();
	   buildFrame();
	 }
	 catch(EngineException e1) {
	  System.out.println("Engine Error");
	  throw new ComponentException();
	 }
	 catch(FrameException e1) {
	  System.out.println("Frame Error");
	  throw new ComponentException();
	 }
   }      
   protected void buildEngine() throws EngineException {
	 if(!enginesGood)
	  throw new EngineException();
   }      
   protected void buildFrame() throws FrameException {
	 if(!framesGood)
	  throw new FrameException();
   }      
}