
package magercises.waitstack.solution;

/* 
   A modification of SimpleStack, WaitStack makes callers to pop
   wait when the stack is empty.  When a new item is pushed onto
   the stack, the waiting threads will be notified.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class WaitStack {
  protected Vector stackVector;
  

  public WaitStack() {
	stackVector = new Vector(10);
  }    
  /** pop will force caller to wait if stack is empty */
  public synchronized Object pop() {
	Object item;
	while(stackVector.size() == 0) {
	try { wait();  }
	catch (InterruptedException e) { }
	  }	
	item = stackVector.elementAt(stackVector.size()-1);
	stackVector.removeElementAt(stackVector.size()-1);
	return item;
  }    
  public synchronized void push(Object item) {
	stackVector.addElement(item);
	notifyAll();
  }    
  public synchronized String toString() {
	return "WaitStack: " + stackVector;
  }    
}